hdu 5747 Aaronson(贪心)

Aaronson

Time Limit: 4000/2000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others)
Total Submission(s): 173    Accepted Submission(s): 106


Problem Description
Recently, Peter saw the equation  x0+2x1+4x2+...+2mxm=n . He wants to find a solution  (x0,x1,x2,...,xm)  in such a manner that  i=0mxi  is minimum and every  xi  ( 0im ) is non-negative.
 

Input
There are multiple test cases. The first line of input contains an integer  T   (1T105) , indicating the number of test cases. For each test case:

The first contains two integers  n  and  m   (0n,m109) .
 

Output
For each test case, output the minimum value of  i=0mxi .
 

Sample Input
  
  
10 1 2 3 2 5 2 10 2 10 3 10 4 13 5 20 4 11 11 12 3
 

Sample Output
  
  
1 2 2 3 2 2 3 2 3 2
题意:

x0+2x1+4x2+...+2mxm=n  给m和m。求最小的x序列之和

思路:10的9次方最多是2的30次方,我们贪心的每次从最高位取到不能取,最后的和一定是最小的

因为是二进制所以一定可以拼出n

代码:

#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cmath>
using namespace std;
long long pow_mod(long long a,long long n)
{
    long long ans=1;
    while(n)
    {
        if(n&1) ans*=a;
        a*=a;
        n>>=1;
    }
    return ans;
}
int main()
{
    int T;
    long long n,m;
    scanf("%d",&T);
    while(T--)
    {
        scanf("%lld %lld",&n,&m);
        long long ans=0;
        if(m>30) m=30;
        while(n)
        {
            long long t=n/pow_mod(2,m);
            ans+=t;
            n-=t*pow_mod(2,m);
            m--;
        }
        printf("%d\n",ans);
    }
    return 0;
}




  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值